=== debian/changelog ===
mercurial (7.1.1-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Julien Cristau <jcristau@debian.org>  Tue, 07 Oct 2025 18:06:28 +0200
