=== debian/changelog ===
mercurial (7.2-4) unstable; urgency=medium

  * Remove tla from autopkgtest deps.
  * Also skip test-sparse-revlog-upgrade.t on riscv64 due to more timeouts.

 -- Julien Cristau <jcristau@debian.org>  Mon, 23 Feb 2026 16:23:41 +0100

mercurial (7.2-3) unstable; urgency=medium

  * Skip test-revset.t and test-sparse-revlog-partial.t on riscv64 due to
    timeouts.

 -- Julien Cristau <jcristau@debian.org>  Mon, 16 Feb 2026 17:27:31 +0100

mercurial (7.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Julien Cristau <jcristau@debian.org>  Mon, 09 Feb 2026 15:26:36 +0100

mercurial (7.2-1) experimental; urgency=medium

  * New upstream release
  * Fix pybuild call for multiple supported versions (closes: #1121613)
  * Refresh debian/upstream/signing-key.asc.

 -- Julien Cristau <jcristau@debian.org>  Mon, 02 Feb 2026 19:08:52 +0100
