=== debian/tests/control ===
Tests: testsuite
Depends:
    @,
    python3-packaging,
    zip,
    unzip,
    netbase,
    subversion,
    python3-subversion,
    cvs,
    bzr,
    git,
    darcs,
    gcc,
    python3-dev,
    less,
    gettext,
    pylint,
    python3-pygments,
    python3-docutils,
    sqlite3,
    clang-format,
    python3-vcr,
    python3-fuzzywuzzy,
    python3-pygit2,
Restrictions: allow-stderr
